// math functions

gmexport double ds_bin_bin_add(double dest_id, double id1, double id2) {
	unsigned long xx,yy,zz;
	ds_bin *dest,*bin1,*bin2;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin1=search_bin((unsigned long) id1))==NULL) return -1;
	if((bin2=search_bin((unsigned long) id2))==NULL) return -1;
	if(!(dest->x==bin1->x && bin1->x==bin2->x && dest->y==bin1->y && bin1->y==bin2->y && dest->z==bin1->z && bin1->z==bin2->z)) {
		return 0;
	}
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				bin_set(dest,xx,yy,zz,bin_get(bin1,xx,yy,zz)+bin_get(bin2,xx,yy,zz));
			}
		}
	}
	return 1;
}

gmexport double ds_bin_bin_subtract(double dest_id, double id1, double id2) {
	unsigned long xx,yy,zz;
	ds_bin *dest,*bin1,*bin2;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin1=search_bin((unsigned long) id1))==NULL) return -1;
	if((bin2=search_bin((unsigned long) id2))==NULL) return -1;
	if(!(dest->x==bin1->x && bin1->x==bin2->x && dest->y==bin1->y && bin1->y==bin2->y && dest->z==bin1->z && bin1->z==bin2->z)) {
		return 0;
	}
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				bin_set(dest,xx,yy,zz,bin_get(bin1,xx,yy,zz)-bin_get(bin2,xx,yy,zz));
			}
		}
	}
	return 1;
}

gmexport double ds_bin_bin_multiply(double dest_id, double id1, double id2) {
	unsigned long xx,yy,zz;
	ds_bin *dest,*bin1,*bin2;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin1=search_bin((unsigned long) id1))==NULL) return -1;
	if((bin2=search_bin((unsigned long) id2))==NULL) return -1;
	if(!(dest->x==bin1->x && bin1->x==bin2->x && dest->y==bin1->y && bin1->y==bin2->y && dest->z==bin1->z && bin1->z==bin2->z)) {
		return 0;
	}
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				bin_set(dest,xx,yy,zz,bin_get(bin1,xx,yy,zz)*bin_get(bin2,xx,yy,zz));
			}
		}
	}
	return 1;
}

gmexport double ds_bin_bin_divide(double dest_id, double id1, double id2) {
	unsigned long xx,yy,zz;
	ds_bin *dest,*bin1,*bin2;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin1=search_bin((unsigned long) id1))==NULL) return -1;
	if((bin2=search_bin((unsigned long) id2))==NULL) return -1;
	if(!(dest->x==bin1->x && bin1->x==bin2->x && dest->y==bin1->y && bin1->y==bin2->y && dest->z==bin1->z && bin1->z==bin2->z)) {
		return 0;
	}
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				bin_set(dest,xx,yy,zz,bin_get(bin1,xx,yy,zz)/bin_get(bin2,xx,yy,zz));
			}
		}
	}
	return 1;
}

// expression functions

gmexport double ds_bin_bin_equal(double dest_id, double id1, double id2, double trueval, double falseval) {
	unsigned long xx,yy,zz;
	ds_bin *dest,*bin1,*bin2;
	uint32_t truevalue,falsevalue;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin1=search_bin((unsigned long) id1))==NULL) return -1;
	if((bin2=search_bin((unsigned long) id2))==NULL) return -1;
	if(!(dest->x==bin1->x && bin1->x==bin2->x && dest->y==bin1->y && bin1->y==bin2->y && dest->z==bin1->z && bin1->z==bin2->z)) {
		return 0;
	}
	truevalue = (uint32_t) trueval;
	falsevalue = (uint32_t) falseval;
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				bin_set(dest,xx,yy,zz,((bin_get(bin1,xx,yy,zz)==bin_get(bin2,xx,yy,zz))?(truevalue):(falsevalue)));
			}
		}
	}
	return 1;
}

gmexport double ds_bin_bin_notequal(double dest_id, double id1, double id2, double trueval, double falseval) {
	unsigned long xx,yy,zz;
	ds_bin *dest,*bin1,*bin2;
	uint32_t truevalue,falsevalue;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin1=search_bin((unsigned long) id1))==NULL) return -1;
	if((bin2=search_bin((unsigned long) id2))==NULL) return -1;
	if(!(dest->x==bin1->x && bin1->x==bin2->x && dest->y==bin1->y && bin1->y==bin2->y && dest->z==bin1->z && bin1->z==bin2->z)) {
		return 0;
	}
	truevalue = (uint32_t) trueval;
	falsevalue = (uint32_t) falseval;
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				bin_set(dest,xx,yy,zz,((bin_get(bin1,xx,yy,zz)!=bin_get(bin2,xx,yy,zz))?(truevalue):(falsevalue)));
			}
		}
	}
	return 1;
}

gmexport double ds_bin_bin_greaterthan(double dest_id, double id1, double id2, double trueval, double falseval) {
	unsigned long xx,yy,zz;
	ds_bin *dest,*bin1,*bin2;
	uint32_t truevalue,falsevalue;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin1=search_bin((unsigned long) id1))==NULL) return -1;
	if((bin2=search_bin((unsigned long) id2))==NULL) return -1;
	if(!(dest->x==bin1->x && bin1->x==bin2->x && dest->y==bin1->y && bin1->y==bin2->y && dest->z==bin1->z && bin1->z==bin2->z)) {
		return 0;
	}
	truevalue = (uint32_t) trueval;
	falsevalue = (uint32_t) falseval;
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				bin_set(dest,xx,yy,zz,((bin_get(bin1,xx,yy,zz)>bin_get(bin2,xx,yy,zz))?(truevalue):(falsevalue)));
			}
		}
	}
	return 1;
}

gmexport double ds_bin_bin_greaterthanorequal(double dest_id, double id1, double id2, double trueval, double falseval) {
	unsigned long xx,yy,zz;
	ds_bin *dest,*bin1,*bin2;
	uint32_t truevalue,falsevalue;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin1=search_bin((unsigned long) id1))==NULL) return -1;
	if((bin2=search_bin((unsigned long) id2))==NULL) return -1;
	if(!(dest->x==bin1->x && bin1->x==bin2->x && dest->y==bin1->y && bin1->y==bin2->y && dest->z==bin1->z && bin1->z==bin2->z)) {
		return 0;
	}
	truevalue = (uint32_t) trueval;
	falsevalue = (uint32_t) falseval;
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				bin_set(dest,xx,yy,zz,((bin_get(bin1,xx,yy,zz)>=bin_get(bin2,xx,yy,zz))?(truevalue):(falsevalue)));
			}
		}
	}
	return 1;
}

gmexport double ds_bin_bin_lessthan(double dest_id, double id1, double id2, double trueval, double falseval) {
	unsigned long xx,yy,zz;
	ds_bin *dest,*bin1,*bin2;
	uint32_t truevalue,falsevalue;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin1=search_bin((unsigned long) id1))==NULL) return -1;
	if((bin2=search_bin((unsigned long) id2))==NULL) return -1;
	if(!(dest->x==bin1->x && bin1->x==bin2->x && dest->y==bin1->y && bin1->y==bin2->y && dest->z==bin1->z && bin1->z==bin2->z)) {
		return 0;
	}
	truevalue = (uint32_t) trueval;
	falsevalue = (uint32_t) falseval;
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				bin_set(dest,xx,yy,zz,((bin_get(bin1,xx,yy,zz)<bin_get(bin2,xx,yy,zz))?(truevalue):(falsevalue)));
			}
		}
	}
	return 1;
}

gmexport double ds_bin_bin_lessthanorequal(double dest_id, double id1, double id2, double trueval, double falseval) {
	unsigned long xx,yy,zz;
	ds_bin *dest,*bin1,*bin2;
	uint32_t truevalue,falsevalue;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin1=search_bin((unsigned long) id1))==NULL) return -1;
	if((bin2=search_bin((unsigned long) id2))==NULL) return -1;
	if(!(dest->x==bin1->x && bin1->x==bin2->x && dest->y==bin1->y && bin1->y==bin2->y && dest->z==bin1->z && bin1->z==bin2->z)) {
		return 0;
	}
	truevalue = (uint32_t) trueval;
	falsevalue = (uint32_t) falseval;
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				bin_set(dest,xx,yy,zz,((bin_get(bin1,xx,yy,zz)<=bin_get(bin2,xx,yy,zz))?(truevalue):(falsevalue)));
			}
		}
	}
	return 1;
}

// replace-expression functions

gmexport double ds_bin_bin_replaceequal(double dest_id, double id1, double id2, double replaceval) {
	unsigned long xx,yy,zz;
	ds_bin *dest,*bin1,*bin2;
	uint32_t replacevalue;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin1=search_bin((unsigned long) id1))==NULL) return -1;
	if((bin2=search_bin((unsigned long) id2))==NULL) return -1;
	if(!(dest->x==bin1->x && bin1->x==bin2->x && dest->y==bin1->y && bin1->y==bin2->y && dest->z==bin1->z && bin1->z==bin2->z)) {
		return 0;
	}
	replacevalue = (uint32_t) replaceval;
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				if(bin_get(bin1,xx,yy,zz)==bin_get(bin2,xx,yy,zz)) {
					bin_set(dest,xx,yy,zz,replacevalue);
				}
			}
		}
	}
	return 1;
}

gmexport double ds_bin_bin_replacenotequal(double dest_id, double id1, double id2, double replaceval) {
	unsigned long xx,yy,zz;
	ds_bin *dest,*bin1,*bin2;
	uint32_t replacevalue;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin1=search_bin((unsigned long) id1))==NULL) return -1;
	if((bin2=search_bin((unsigned long) id2))==NULL) return -1;
	if(!(dest->x==bin1->x && bin1->x==bin2->x && dest->y==bin1->y && bin1->y==bin2->y && dest->z==bin1->z && bin1->z==bin2->z)) {
		return 0;
	}
	replacevalue = (uint32_t) replaceval;
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				if(bin_get(bin1,xx,yy,zz)!=bin_get(bin2,xx,yy,zz)) {
					bin_set(dest,xx,yy,zz,replacevalue);
				}
			}
		}
	}
	return 1;
}

gmexport double ds_bin_bin_replacegreaterthan(double dest_id, double id1, double id2, double replaceval) {
	unsigned long xx,yy,zz;
	ds_bin *dest,*bin1,*bin2;
	uint32_t replacevalue;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin1=search_bin((unsigned long) id1))==NULL) return -1;
	if((bin2=search_bin((unsigned long) id2))==NULL) return -1;
	if(!(dest->x==bin1->x && bin1->x==bin2->x && dest->y==bin1->y && bin1->y==bin2->y && dest->z==bin1->z && bin1->z==bin2->z)) {
		return 0;
	}
	replacevalue = (uint32_t) replaceval;
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				if(bin_get(bin1,xx,yy,zz)>bin_get(bin2,xx,yy,zz)) {
					bin_set(dest,xx,yy,zz,replacevalue);
				}
			}
		}
	}
	return 1;
}

gmexport double ds_bin_bin_replacegreaterthanorequal(double dest_id, double id1, double id2, double replaceval) {
	unsigned long xx,yy,zz;
	ds_bin *dest,*bin1,*bin2;
	uint32_t replacevalue;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin1=search_bin((unsigned long) id1))==NULL) return -1;
	if((bin2=search_bin((unsigned long) id2))==NULL) return -1;
	if(!(dest->x==bin1->x && bin1->x==bin2->x && dest->y==bin1->y && bin1->y==bin2->y && dest->z==bin1->z && bin1->z==bin2->z)) {
		return 0;
	}
	replacevalue = (uint32_t) replaceval;
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				if(bin_get(bin1,xx,yy,zz)>=bin_get(bin2,xx,yy,zz)) {
					bin_set(dest,xx,yy,zz,replacevalue);
				}
			}
		}
	}
	return 1;
}

gmexport double ds_bin_bin_replacelessthan(double dest_id, double id1, double id2, double replaceval) {
	unsigned long xx,yy,zz;
	ds_bin *dest,*bin1,*bin2;
	uint32_t replacevalue;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin1=search_bin((unsigned long) id1))==NULL) return -1;
	if((bin2=search_bin((unsigned long) id2))==NULL) return -1;
	if(!(dest->x==bin1->x && bin1->x==bin2->x && dest->y==bin1->y && bin1->y==bin2->y && dest->z==bin1->z && bin1->z==bin2->z)) {
		return 0;
	}
	replacevalue = (uint32_t) replaceval;
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				if(bin_get(bin1,xx,yy,zz)<bin_get(bin2,xx,yy,zz)) {
					bin_set(dest,xx,yy,zz,replacevalue);
				}
			}
		}
	}
	return 1;
}

gmexport double ds_bin_bin_replacelessthanorequal(double dest_id, double id1, double id2, double replaceval) {
	unsigned long xx,yy,zz;
	ds_bin *dest,*bin1,*bin2;
	uint32_t replacevalue;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin1=search_bin((unsigned long) id1))==NULL) return -1;
	if((bin2=search_bin((unsigned long) id2))==NULL) return -1;
	if(!(dest->x==bin1->x && bin1->x==bin2->x && dest->y==bin1->y && bin1->y==bin2->y && dest->z==bin1->z && bin1->z==bin2->z)) {
		return 0;
	}
	replacevalue = (uint32_t) replaceval;
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				if(bin_get(bin1,xx,yy,zz)<=bin_get(bin2,xx,yy,zz)) {
					bin_set(dest,xx,yy,zz,replacevalue);
				}
			}
		}
	}
	return 1;
}

// boolean functions

gmexport double ds_bin_bin_boolean_and(double dest_id, double id1, double id2) {
	unsigned long xx,yy,zz;
	ds_bin *dest,*bin1,*bin2;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin1=search_bin((unsigned long) id1))==NULL) return -1;
	if((bin2=search_bin((unsigned long) id2))==NULL) return -1;
	if(!(dest->x==bin1->x && bin1->x==bin2->x && dest->y==bin1->y && bin1->y==bin2->y && dest->z==bin1->z && bin1->z==bin2->z)) {
		return 0;
	}
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				bin_set(dest,xx,yy,zz,bin_get(bin1,xx,yy,zz) && bin_get(bin2,xx,yy,zz));
			}
		}
	}
	return 1;
}

gmexport double ds_bin_bin_boolean_or(double dest_id, double id1, double id2) {
	unsigned long xx,yy,zz;
	ds_bin *dest,*bin1,*bin2;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin1=search_bin((unsigned long) id1))==NULL) return -1;
	if((bin2=search_bin((unsigned long) id2))==NULL) return -1;
	if(!(dest->x==bin1->x && bin1->x==bin2->x && dest->y==bin1->y && bin1->y==bin2->y && dest->z==bin1->z && bin1->z==bin2->z)) {
		return 0;
	}
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				bin_set(dest,xx,yy,zz,bin_get(bin1,xx,yy,zz) || bin_get(bin2,xx,yy,zz));
			}
		}
	}
	return 1;
}

gmexport double ds_bin_bin_boolean_xor(double dest_id, double id1, double id2) {
	unsigned long xx,yy,zz;
	ds_bin *dest,*bin1,*bin2;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin1=search_bin((unsigned long) id1))==NULL) return -1;
	if((bin2=search_bin((unsigned long) id2))==NULL) return -1;
	if(!(dest->x==bin1->x && bin1->x==bin2->x && dest->y==bin1->y && bin1->y==bin2->y && dest->z==bin1->z && bin1->z==bin2->z)) {
		return 0;
	}
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				bin_set(dest,xx,yy,zz,bin_get(bin1,xx,yy,zz) xor bin_get(bin2,xx,yy,zz));
			}
		}
	}
	return 1;
}

gmexport double ds_bin_bin_boolean_nand(double dest_id, double id1, double id2) {
	unsigned long xx,yy,zz;
	ds_bin *dest,*bin1,*bin2;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin1=search_bin((unsigned long) id1))==NULL) return -1;
	if((bin2=search_bin((unsigned long) id2))==NULL) return -1;
	if(!(dest->x==bin1->x && bin1->x==bin2->x && dest->y==bin1->y && bin1->y==bin2->y && dest->z==bin1->z && bin1->z==bin2->z)) {
		return 0;
	}
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				bin_set(dest,xx,yy,zz,!(bin_get(bin1,xx,yy,zz) && bin_get(bin2,xx,yy,zz)));
			}
		}
	}
	return 1;
}

gmexport double ds_bin_bin_boolean_nor(double dest_id, double id1, double id2) {
	unsigned long xx,yy,zz;
	ds_bin *dest,*bin1,*bin2;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin1=search_bin((unsigned long) id1))==NULL) return -1;
	if((bin2=search_bin((unsigned long) id2))==NULL) return -1;
	if(!(dest->x==bin1->x && bin1->x==bin2->x && dest->y==bin1->y && bin1->y==bin2->y && dest->z==bin1->z && bin1->z==bin2->z)) {
		return 0;
	}
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				bin_set(dest,xx,yy,zz,!(bin_get(bin1,xx,yy,zz) || bin_get(bin2,xx,yy,zz)));
			}
		}
	}
	return 1;
}

gmexport double ds_bin_bin_boolean_nxor(double dest_id, double id1, double id2) {
	unsigned long xx,yy,zz;
	ds_bin *dest,*bin1,*bin2;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin1=search_bin((unsigned long) id1))==NULL) return -1;
	if((bin2=search_bin((unsigned long) id2))==NULL) return -1;
	if(!(dest->x==bin1->x && bin1->x==bin2->x && dest->y==bin1->y && bin1->y==bin2->y && dest->z==bin1->z && bin1->z==bin2->z)) {
		return 0;
	}
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				bin_set(dest,xx,yy,zz,!(bin_get(bin1,xx,yy,zz) xor bin_get(bin2,xx,yy,zz)));
			}
		}
	}
	return 1;
}

// bitwise functions

gmexport double ds_bin_bin_bitwise_and(double dest_id, double id1, double id2) {
	unsigned long i;
	ds_bin *dest,*bin1,*bin2;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin1=search_bin((unsigned long) id1))==NULL) return -1;
	if((bin2=search_bin((unsigned long) id2))==NULL) return -1;
	if(!(dest->bits==bin1->bits && bin1->bits==bin2->bits && dest->x==bin1->x && bin1->x==bin2->x && dest->y==bin1->y && bin1->y==bin2->y && dest->z==bin1->z && bin1->z==bin2->z)) {
		return 0;
	}
	for(i=0;i<dest->count;++i) {
		dest->data[i] = (bin1->data[i]) & (bin2->data[i]);
	}
	return 1;
}

gmexport double ds_bin_bin_bitwise_or(double dest_id, double id1, double id2) {
	unsigned long i;
	ds_bin *dest,*bin1,*bin2;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin1=search_bin((unsigned long) id1))==NULL) return -1;
	if((bin2=search_bin((unsigned long) id2))==NULL) return -1;
	if(!(dest->bits==bin1->bits && bin1->bits==bin2->bits && dest->x==bin1->x && bin1->x==bin2->x && dest->y==bin1->y && bin1->y==bin2->y && dest->z==bin1->z && bin1->z==bin2->z)) {
		return 0;
	}
	for(i=0;i<dest->count;++i) {
		dest->data[i] = (bin1->data[i]) | (bin2->data[i]);
	}
	return 1;
}

gmexport double ds_bin_bin_bitwise_xor(double dest_id, double id1, double id2) {
	unsigned long i;
	ds_bin *dest,*bin1,*bin2;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin1=search_bin((unsigned long) id1))==NULL) return -1;
	if((bin2=search_bin((unsigned long) id2))==NULL) return -1;
	if(!(dest->bits==bin1->bits && bin1->bits==bin2->bits && dest->x==bin1->x && bin1->x==bin2->x && dest->y==bin1->y && bin1->y==bin2->y && dest->z==bin1->z && bin1->z==bin2->z)) {
		return 0;
	}
	for(i=0;i<dest->count;++i) {
		dest->data[i] = (bin1->data[i]) ^ (bin2->data[i]);
	}
	return 1;
}

gmexport double ds_bin_bin_bitwise_nand(double dest_id, double id1, double id2) {
	unsigned long i;
	ds_bin *dest,*bin1,*bin2;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin1=search_bin((unsigned long) id1))==NULL) return -1;
	if((bin2=search_bin((unsigned long) id2))==NULL) return -1;
	if(!(dest->bits==bin1->bits && bin1->bits==bin2->bits && dest->x==bin1->x && bin1->x==bin2->x && dest->y==bin1->y && bin1->y==bin2->y && dest->z==bin1->z && bin1->z==bin2->z)) {
		return 0;
	}
	for(i=0;i<dest->count;++i) {
		dest->data[i] = ~( (bin1->data[i]) & (bin2->data[i]) );
	}
	return 1;
}

gmexport double ds_bin_bin_bitwise_nor(double dest_id, double id1, double id2) {
	unsigned long i;
	ds_bin *dest,*bin1,*bin2;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin1=search_bin((unsigned long) id1))==NULL) return -1;
	if((bin2=search_bin((unsigned long) id2))==NULL) return -1;
	if(!(dest->bits==bin1->bits && bin1->bits==bin2->bits && dest->x==bin1->x && bin1->x==bin2->x && dest->y==bin1->y && bin1->y==bin2->y && dest->z==bin1->z && bin1->z==bin2->z)) {
		return 0;
	}
	for(i=0;i<dest->count;++i) {
		dest->data[i] = ~( (bin1->data[i]) | (bin2->data[i]) );
	}
	return 1;
}

gmexport double ds_bin_bin_bitwise_nxor(double dest_id, double id1, double id2) {
	unsigned long i;
	ds_bin *dest,*bin1,*bin2;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin1=search_bin((unsigned long) id1))==NULL) return -1;
	if((bin2=search_bin((unsigned long) id2))==NULL) return -1;
	if(!(dest->bits==bin1->bits && bin1->bits==bin2->bits && dest->x==bin1->x && bin1->x==bin2->x && dest->y==bin1->y && bin1->y==bin2->y && dest->z==bin1->z && bin1->z==bin2->z)) {
		return 0;
	}
	for(i=0;i<dest->count;++i) {
		dest->data[i] = ~( (bin1->data[i]) ^ (bin2->data[i]) );
	}
	return 1;
}

