// reading/writing functions

gmexport double ds_bin_min_region(double x, double y, double z, double size_x, double size_y, double size_z) {
	unsigned long xx,yy,zz,sx,sy,sz,sizex,sizey,sizez;
	uint32_t temp,value;
	if(selectedbin==NULL) return -1;
	sx = (unsigned long) x;
	sy = (unsigned long) y;
	sz = (unsigned long) z;
	sizex = (unsigned long) size_x;
	sizey = (unsigned long) size_y;
	sizez = (unsigned long) size_z;
	if(!(sx+sizex<=selectedbin->x && sy+sizey<=selectedbin->y && sz+sizez<=selectedbin->z)) {
		return 0;
	}
	value = (uint32_t)(-1);
	for(zz=0;zz<sizez;++zz) {
		for(yy=0;yy<sizey;++yy) {
			for(xx=0;xx<sizex;++xx) {
				if((temp=bin_get(selectedbin,sx+xx,sy+yy,sz+zz))<value) {
					value = temp;
					return_x = xx;
					return_y = yy;
					return_z = zz;
				}
			}
		}
	}
	return value;
}

gmexport double ds_bin_max_region(double x, double y, double z, double size_x, double size_y, double size_z) {
	unsigned long xx,yy,zz,sx,sy,sz,sizex,sizey,sizez;
	uint32_t temp,value;
	if(selectedbin==NULL) return -1;
	sx = (unsigned long) x;
	sy = (unsigned long) y;
	sz = (unsigned long) z;
	sizex = (unsigned long) size_x;
	sizey = (unsigned long) size_y;
	sizez = (unsigned long) size_z;
	if(!(sx+sizex<=selectedbin->x && sy+sizey<=selectedbin->y && sz+sizez<=selectedbin->z)) {
		return 0;
	}
	value = (uint32_t)(0);
	for(zz=0;zz<sizez;++zz) {
		for(yy=0;yy<sizey;++yy) {
			for(xx=0;xx<sizex;++xx) {
				if((temp=bin_get(selectedbin,sx+xx,sy+yy,sz+zz))>value) {
					value = temp;
					return_x = sx+xx;
					return_y = sy+yy;
					return_z = sz+zz;
				}
			}
		}
	}
	return value;
}

gmexport double ds_bin_find_region(double x, double y, double z, double size_x, double size_y, double size_z, double val) {
	unsigned long xx,yy,zz,sx,sy,sz,sizex,sizey,sizez;
	uint32_t value;
	if(selectedbin==NULL) return -1;
	sx = (unsigned long) x;
	sy = (unsigned long) y;
	sz = (unsigned long) z;
	sizex = (unsigned long) size_x;
	sizey = (unsigned long) size_y;
	sizez = (unsigned long) size_z;
	if(!(sx+sizex<=selectedbin->x && sy+sizey<=selectedbin->y && sz+sizez<=selectedbin->z)) {
		return 0;
	}
	value = (uint32_t) val;
	for(zz=0;zz<sizez;++zz) {
		for(yy=0;yy<sizey;++yy) {
			for(xx=0;xx<sizex;++xx) {
				if(bin_get(selectedbin,sx+xx,sy+yy,sz+zz)==value) {
					return_x = sx+xx;
					return_y = sy+yy;
					return_z = sz+zz;
					return 1;
				}
			}
		}
	}
	return 0;
}

gmexport double ds_bin_find_region_continue(double x, double y, double z, double size_x, double size_y, double size_z, double val) {
	unsigned long xx,yy,zz,sx,sy,sz,sizex,sizey,sizez;
	uint32_t value;
	if(selectedbin==NULL) return -1;
	sx = (unsigned long) x;
	sy = (unsigned long) y;
	sz = (unsigned long) z;
	sizex = (unsigned long) size_x;
	sizey = (unsigned long) size_y;
	sizez = (unsigned long) size_z;
	if(!(sx+sizex<=selectedbin->x && sy+sizey<=selectedbin->y && sz+sizez<=selectedbin->z)) {
		return 0;
	}
	value = (uint32_t) val;
	xx = return_x-sx+1;
	yy = return_y-sy;
	zz = return_z-sz;
	for(;zz<sizez;++zz) {
		for(;yy<sizey;++yy) {
			for(;xx<sizex;++xx) {
				if(bin_get(selectedbin,sx+xx,sy+yy,sz+zz)==value) {
					return_x = sx+xx;
					return_y = sy+yy;
					return_z = sz+zz;
					return 1;
				}
			}
			xx = 0;
		}
		yy = 0;
	}
	return 0;
}

gmexport double ds_bin_sum_region(double x, double y, double z, double size_x, double size_y, double size_z) {
	unsigned long xx,yy,zz,sx,sy,sz,sizex,sizey,sizez;
	unsigned long long value;
	if(selectedbin==NULL) return -1;
	sx = (unsigned long) x;
	sy = (unsigned long) y;
	sz = (unsigned long) z;
	sizex = (unsigned long) size_x;
	sizey = (unsigned long) size_y;
	sizez = (unsigned long) size_z;
	if(!(sx+sizex<=selectedbin->x && sy+sizey<=selectedbin->y && sz+sizez<=selectedbin->z)) {
		return 0;
	}
	value = 0;
	for(zz=0;zz<sizez;++zz) {
		for(yy=0;yy<sizey;++yy) {
			for(xx=0;xx<sizex;++xx) {
				value += bin_get(selectedbin,sx+xx,sy+yy,sz+zz);
			}
		}
	}
	return value;
}

gmexport double ds_bin_weightedrandom_region(double x, double y, double z, double size_x, double size_y, double size_z, double random) {
	unsigned long xx,yy,zz,sx,sy,sz,sizex,sizey,sizez;
	unsigned long long number;
	uint32_t temp;
	if(selectedbin==NULL) return -1;
	sx = (unsigned long) x;
	sy = (unsigned long) y;
	sz = (unsigned long) z;
	sizex = (unsigned long) size_x;
	sizey = (unsigned long) size_y;
	sizez = (unsigned long) size_z;
	if(!(sx+sizex<=selectedbin->x && sy+sizey<=selectedbin->y && sz+sizez<=selectedbin->z)) {
		return 0;
	}
	number = 0;
	for(zz=0;zz<sizez;++zz) {
		for(yy=0;yy<sizey;++yy) {
			for(xx=0;xx<sizex;++xx) {
				number += bin_get(selectedbin,sx+xx,sy+yy,sz+zz);
			}
		}
	}
	if(number==0) return 0;
	number = (unsigned long long)(random*(double)(number));
	for(zz=0;zz<sizez;++zz) {
		for(yy=0;yy<sizey;++yy) {
			for(xx=0;xx<sizex;++xx) {
				temp = bin_get(selectedbin,sx+xx,sy+yy,sz+zz);
				if(number<temp) {
					return_x = xx;
					return_y = yy;
					return_z = zz;
					return 1;
				}
				number -= temp;
			}
		}
	}
	return 0;
}

gmexport double ds_bin_set_region(double x, double y, double z, double size_x, double size_y, double size_z, double val) {
	unsigned long xx,yy,zz,sx,sy,sz,sizex,sizey,sizez;
	uint32_t value;
	if(selectedbin==NULL) return -1;
	sx = (unsigned long) x;
	sy = (unsigned long) y;
	sz = (unsigned long) z;
	sizex = (unsigned long) size_x;
	sizey = (unsigned long) size_y;
	sizez = (unsigned long) size_z;
	if(!(sx+sizex<=selectedbin->x && sy+sizey<=selectedbin->y && sz+sizez<=selectedbin->z)) {
		return 0;
	}
	value = (uint32_t) val;
	for(zz=0;zz<sizez;++zz) {
		for(yy=0;yy<sizey;++yy) {
			for(xx=0;xx<sizex;++xx) {
				bin_set(selectedbin,sx+xx,sy+yy,sz+zz,value);
			}
		}
	}
	return 1;
}

// math functions

gmexport double ds_bin_add_region(double x, double y, double z, double size_x, double size_y, double size_z, double val) {
	unsigned long xx,yy,zz,sx,sy,sz,sizex,sizey,sizez;
	uint32_t value;
	if(selectedbin==NULL) return -1;
	sx = (unsigned long) x;
	sy = (unsigned long) y;
	sz = (unsigned long) z;
	sizex = (unsigned long) size_x;
	sizey = (unsigned long) size_y;
	sizez = (unsigned long) size_z;
	if(!(sx+sizex<=selectedbin->x && sy+sizey<=selectedbin->y && sz+sizez<=selectedbin->z)) {
		return 0;
	}
	value = (uint32_t) val;
	for(zz=0;zz<sizez;++zz) {
		for(yy=0;yy<sizey;++yy) {
			for(xx=0;xx<sizex;++xx) {
				bin_set(selectedbin,sx+xx,sy+yy,sz+zz,bin_get(selectedbin,sx+xx,sy+yy,sz+zz)+value);
			}
		}
	}
	return 1;
}

gmexport double ds_bin_subtract_region(double x, double y, double z, double size_x, double size_y, double size_z, double val) {
	unsigned long xx,yy,zz,sx,sy,sz,sizex,sizey,sizez;
	uint32_t value;
	if(selectedbin==NULL) return -1;
	sx = (unsigned long) x;
	sy = (unsigned long) y;
	sz = (unsigned long) z;
	sizex = (unsigned long) size_x;
	sizey = (unsigned long) size_y;
	sizez = (unsigned long) size_z;
	if(!(sx+sizex<=selectedbin->x && sy+sizey<=selectedbin->y && sz+sizez<=selectedbin->z)) {
		return 0;
	}
	value = (uint32_t) val;
	for(zz=0;zz<sizez;++zz) {
		for(yy=0;yy<sizey;++yy) {
			for(xx=0;xx<sizex;++xx) {
				bin_set(selectedbin,sx+xx,sy+yy,sz+zz,bin_get(selectedbin,sx+xx,sy+yy,sz+zz)-value);
			}
		}
	}
	return 1;
}

gmexport double ds_bin_invsubtract_region(double x, double y, double z, double size_x, double size_y, double size_z, double val) {
	unsigned long xx,yy,zz,sx,sy,sz,sizex,sizey,sizez;
	uint32_t value;
	if(selectedbin==NULL) return -1;
	sx = (unsigned long) x;
	sy = (unsigned long) y;
	sz = (unsigned long) z;
	sizex = (unsigned long) size_x;
	sizey = (unsigned long) size_y;
	sizez = (unsigned long) size_z;
	if(!(sx+sizex<=selectedbin->x && sy+sizey<=selectedbin->y && sz+sizez<=selectedbin->z)) {
		return 0;
	}
	value = (uint32_t) val;
	for(zz=0;zz<sizez;++zz) {
		for(yy=0;yy<sizey;++yy) {
			for(xx=0;xx<sizex;++xx) {
				bin_set(selectedbin,sx+xx,sy+yy,sz+zz,value-bin_get(selectedbin,sx+xx,sy+yy,sz+zz));
			}
		}
	}
	return 1;
}

gmexport double ds_bin_multiply_region(double x, double y, double z, double size_x, double size_y, double size_z, double val) {
	unsigned long xx,yy,zz,sx,sy,sz,sizex,sizey,sizez;
	uint32_t value;
	if(selectedbin==NULL) return -1;
	sx = (unsigned long) x;
	sy = (unsigned long) y;
	sz = (unsigned long) z;
	sizex = (unsigned long) size_x;
	sizey = (unsigned long) size_y;
	sizez = (unsigned long) size_z;
	if(!(sx+sizex<=selectedbin->x && sy+sizey<=selectedbin->y && sz+sizez<=selectedbin->z)) {
		return 0;
	}
	value = (uint32_t) val;
	for(zz=0;zz<sizez;++zz) {
		for(yy=0;yy<sizey;++yy) {
			for(xx=0;xx<sizex;++xx) {
				bin_set(selectedbin,sx+xx,sy+yy,sz+zz,bin_get(selectedbin,sx+xx,sy+yy,sz+zz)*value);
			}
		}
	}
	return 1;
}

gmexport double ds_bin_divide_region(double x, double y, double z, double size_x, double size_y, double size_z, double val) {
	unsigned long xx,yy,zz,sx,sy,sz,sizex,sizey,sizez;
	uint32_t value;
	if(selectedbin==NULL) return -1;
	sx = (unsigned long) x;
	sy = (unsigned long) y;
	sz = (unsigned long) z;
	sizex = (unsigned long) size_x;
	sizey = (unsigned long) size_y;
	sizez = (unsigned long) size_z;
	if(!(sx+sizex<=selectedbin->x && sy+sizey<=selectedbin->y && sz+sizez<=selectedbin->z)) {
		return 0;
	}
	value = (uint32_t) val;
	for(zz=0;zz<sizez;++zz) {
		for(yy=0;yy<sizey;++yy) {
			for(xx=0;xx<sizex;++xx) {
				bin_set(selectedbin,sx+xx,sy+yy,sz+zz,bin_get(selectedbin,sx+xx,sy+yy,sz+zz)/value);
			}
		}
	}
	return 1;
}

gmexport double ds_bin_invdivide_region(double x, double y, double z, double size_x, double size_y, double size_z, double val) {
	unsigned long xx,yy,zz,sx,sy,sz,sizex,sizey,sizez;
	uint32_t value;
	if(selectedbin==NULL) return -1;
	sx = (unsigned long) x;
	sy = (unsigned long) y;
	sz = (unsigned long) z;
	sizex = (unsigned long) size_x;
	sizey = (unsigned long) size_y;
	sizez = (unsigned long) size_z;
	if(!(sx+sizex<=selectedbin->x && sy+sizey<=selectedbin->y && sz+sizez<=selectedbin->z)) {
		return 0;
	}
	value = (uint32_t) val;
	for(zz=0;zz<sizez;++zz) {
		for(yy=0;yy<sizey;++yy) {
			for(xx=0;xx<sizex;++xx) {
				bin_set(selectedbin,sx+xx,sy+yy,sz+zz,value/bin_get(selectedbin,sx+xx,sy+yy,sz+zz));
			}
		}
	}
	return 1;
}

// expression functions

gmexport double ds_bin_equal_region(double x, double y, double z, double size_x, double size_y, double size_z, double val, double trueval, double falseval) {
	unsigned long xx,yy,zz,sx,sy,sz,sizex,sizey,sizez;
	uint32_t value,truevalue,falsevalue;
	if(selectedbin==NULL) return -1;
	sx = (unsigned long) x;
	sy = (unsigned long) y;
	sz = (unsigned long) z;
	sizex = (unsigned long) size_x;
	sizey = (unsigned long) size_y;
	sizez = (unsigned long) size_z;
	if(!(sx+sizex<=selectedbin->x && sy+sizey<=selectedbin->y && sz+sizez<=selectedbin->z)) {
		return 0;
	}
	value = (uint32_t) val;
	truevalue = (uint32_t) trueval;
	falsevalue = (uint32_t) falseval;
	for(zz=0;zz<sizez;++zz) {
		for(yy=0;yy<sizey;++yy) {
			for(xx=0;xx<sizex;++xx) {
				bin_set(selectedbin,sx+xx,sy+yy,sz+zz,((bin_get(selectedbin,sx+xx,sy+yy,sz+zz)==value)?(truevalue):(falsevalue)));
			}
		}
	}
	return 1;
}

gmexport double ds_bin_notequal_region(double x, double y, double z, double size_x, double size_y, double size_z, double val, double trueval, double falseval) {
	unsigned long xx,yy,zz,sx,sy,sz,sizex,sizey,sizez;
	uint32_t value,truevalue,falsevalue;
	if(selectedbin==NULL) return -1;
	sx = (unsigned long) x;
	sy = (unsigned long) y;
	sz = (unsigned long) z;
	sizex = (unsigned long) size_x;
	sizey = (unsigned long) size_y;
	sizez = (unsigned long) size_z;
	if(!(sx+sizex<=selectedbin->x && sy+sizey<=selectedbin->y && sz+sizez<=selectedbin->z)) {
		return 0;
	}
	value = (uint32_t) val;
	truevalue = (uint32_t) trueval;
	falsevalue = (uint32_t) falseval;
	for(zz=0;zz<sizez;++zz) {
		for(yy=0;yy<sizey;++yy) {
			for(xx=0;xx<sizex;++xx) {
				bin_set(selectedbin,sx+xx,sy+yy,sz+zz,((bin_get(selectedbin,sx+xx,sy+yy,sz+zz)!=value)?(truevalue):(falsevalue)));
			}
		}
	}
	return 1;
}

gmexport double ds_bin_greaterthan_region(double x, double y, double z, double size_x, double size_y, double size_z, double val, double trueval, double falseval) {
	unsigned long xx,yy,zz,sx,sy,sz,sizex,sizey,sizez;
	uint32_t value,truevalue,falsevalue;
	if(selectedbin==NULL) return -1;
	sx = (unsigned long) x;
	sy = (unsigned long) y;
	sz = (unsigned long) z;
	sizex = (unsigned long) size_x;
	sizey = (unsigned long) size_y;
	sizez = (unsigned long) size_z;
	if(!(sx+sizex<=selectedbin->x && sy+sizey<=selectedbin->y && sz+sizez<=selectedbin->z)) {
		return 0;
	}
	value = (uint32_t) val;
	truevalue = (uint32_t) trueval;
	falsevalue = (uint32_t) falseval;
	for(zz=0;zz<sizez;++zz) {
		for(yy=0;yy<sizey;++yy) {
			for(xx=0;xx<sizex;++xx) {
				bin_set(selectedbin,sx+xx,sy+yy,sz+zz,((bin_get(selectedbin,sx+xx,sy+yy,sz+zz)>value)?(truevalue):(falsevalue)));
			}
		}
	}
	return 1;
}

gmexport double ds_bin_greaterthanorequal_region(double x, double y, double z, double size_x, double size_y, double size_z, double val, double trueval, double falseval) {
	unsigned long xx,yy,zz,sx,sy,sz,sizex,sizey,sizez;
	uint32_t value,truevalue,falsevalue;
	if(selectedbin==NULL) return -1;
	sx = (unsigned long) x;
	sy = (unsigned long) y;
	sz = (unsigned long) z;
	sizex = (unsigned long) size_x;
	sizey = (unsigned long) size_y;
	sizez = (unsigned long) size_z;
	if(!(sx+sizex<=selectedbin->x && sy+sizey<=selectedbin->y && sz+sizez<=selectedbin->z)) {
		return 0;
	}
	value = (uint32_t) val;
	truevalue = (uint32_t) trueval;
	falsevalue = (uint32_t) falseval;
	for(zz=0;zz<sizez;++zz) {
		for(yy=0;yy<sizey;++yy) {
			for(xx=0;xx<sizex;++xx) {
				bin_set(selectedbin,sx+xx,sy+yy,sz+zz,((bin_get(selectedbin,sx+xx,sy+yy,sz+zz)>=value)?(truevalue):(falsevalue)));
			}
		}
	}
	return 1;
}

gmexport double ds_bin_lessthan_region(double x, double y, double z, double size_x, double size_y, double size_z, double val, double trueval, double falseval) {
	unsigned long xx,yy,zz,sx,sy,sz,sizex,sizey,sizez;
	uint32_t value,truevalue,falsevalue;
	if(selectedbin==NULL) return -1;
	sx = (unsigned long) x;
	sy = (unsigned long) y;
	sz = (unsigned long) z;
	sizex = (unsigned long) size_x;
	sizey = (unsigned long) size_y;
	sizez = (unsigned long) size_z;
	if(!(sx+sizex<=selectedbin->x && sy+sizey<=selectedbin->y && sz+sizez<=selectedbin->z)) {
		return 0;
	}
	value = (uint32_t) val;
	truevalue = (uint32_t) trueval;
	falsevalue = (uint32_t) falseval;
	for(zz=0;zz<sizez;++zz) {
		for(yy=0;yy<sizey;++yy) {
			for(xx=0;xx<sizex;++xx) {
				bin_set(selectedbin,sx+xx,sy+yy,sz+zz,((bin_get(selectedbin,sx+xx,sy+yy,sz+zz)<value)?(truevalue):(falsevalue)));
			}
		}
	}
	return 1;
}

gmexport double ds_bin_lessthanorequal_region(double x, double y, double z, double size_x, double size_y, double size_z, double val, double trueval, double falseval) {
	unsigned long xx,yy,zz,sx,sy,sz,sizex,sizey,sizez;
	uint32_t value,truevalue,falsevalue;
	if(selectedbin==NULL) return -1;
	sx = (unsigned long) x;
	sy = (unsigned long) y;
	sz = (unsigned long) z;
	sizex = (unsigned long) size_x;
	sizey = (unsigned long) size_y;
	sizez = (unsigned long) size_z;
	if(!(sx+sizex<=selectedbin->x && sy+sizey<=selectedbin->y && sz+sizez<=selectedbin->z)) {
		return 0;
	}
	value = (uint32_t) val;
	truevalue = (uint32_t) trueval;
	falsevalue = (uint32_t) falseval;
	for(zz=0;zz<sizez;++zz) {
		for(yy=0;yy<sizey;++yy) {
			for(xx=0;xx<sizex;++xx) {
				bin_set(selectedbin,sx+xx,sy+yy,sz+zz,((bin_get(selectedbin,sx+xx,sy+yy,sz+zz)<=value)?(truevalue):(falsevalue)));
			}
		}
	}
	return 1;
}

// replace-expression functions

gmexport double ds_bin_replaceequal_region(double x, double y, double z, double size_x, double size_y, double size_z, double val, double replaceval) {
	unsigned long xx,yy,zz,sx,sy,sz,sizex,sizey,sizez;
	uint32_t value,replacevalue;
	if(selectedbin==NULL) return -1;
	sx = (unsigned long) x;
	sy = (unsigned long) y;
	sz = (unsigned long) z;
	sizex = (unsigned long) size_x;
	sizey = (unsigned long) size_y;
	sizez = (unsigned long) size_z;
	if(!(sx+sizex<=selectedbin->x && sy+sizey<=selectedbin->y && sz+sizez<=selectedbin->z)) {
		return 0;
	}
	value = (uint32_t) val;
	replacevalue = (uint32_t) replaceval;
	for(zz=0;zz<sizez;++zz) {
		for(yy=0;yy<sizey;++yy) {
			for(xx=0;xx<sizex;++xx) {
				if(bin_get(selectedbin,sx+xx,sy+yy,sz+zz)==value) {
					bin_set(selectedbin,sx+xx,sy+yy,sz+zz,replacevalue);
				}
			}
		}
	}
	return 1;
}

gmexport double ds_bin_replacenotequal_region(double x, double y, double z, double size_x, double size_y, double size_z, double val, double replaceval) {
	unsigned long xx,yy,zz,sx,sy,sz,sizex,sizey,sizez;
	uint32_t value,replacevalue;
	if(selectedbin==NULL) return -1;
	sx = (unsigned long) x;
	sy = (unsigned long) y;
	sz = (unsigned long) z;
	sizex = (unsigned long) size_x;
	sizey = (unsigned long) size_y;
	sizez = (unsigned long) size_z;
	if(!(sx+sizex<=selectedbin->x && sy+sizey<=selectedbin->y && sz+sizez<=selectedbin->z)) {
		return 0;
	}
	value = (uint32_t) val;
	replacevalue = (uint32_t) replaceval;
	for(zz=0;zz<sizez;++zz) {
		for(yy=0;yy<sizey;++yy) {
			for(xx=0;xx<sizex;++xx) {
				if(bin_get(selectedbin,sx+xx,sy+yy,sz+zz)!=value) {
					bin_set(selectedbin,sx+xx,sy+yy,sz+zz,replacevalue);
				}
			}
		}
	}
	return 1;
}

gmexport double ds_bin_replacegreaterthan_region(double x, double y, double z, double size_x, double size_y, double size_z, double val, double replaceval) {
	unsigned long xx,yy,zz,sx,sy,sz,sizex,sizey,sizez;
	uint32_t value,replacevalue;
	if(selectedbin==NULL) return -1;
	sx = (unsigned long) x;
	sy = (unsigned long) y;
	sz = (unsigned long) z;
	sizex = (unsigned long) size_x;
	sizey = (unsigned long) size_y;
	sizez = (unsigned long) size_z;
	if(!(sx+sizex<=selectedbin->x && sy+sizey<=selectedbin->y && sz+sizez<=selectedbin->z)) {
		return 0;
	}
	value = (uint32_t) val;
	replacevalue = (uint32_t) replaceval;
	for(zz=0;zz<sizez;++zz) {
		for(yy=0;yy<sizey;++yy) {
			for(xx=0;xx<sizex;++xx) {
				if(bin_get(selectedbin,sx+xx,sy+yy,sz+zz)>value) {
					bin_set(selectedbin,sx+xx,sy+yy,sz+zz,replacevalue);
				}
			}
		}
	}
	return 1;
}

gmexport double ds_bin_replacegreaterthanorequal_region(double x, double y, double z, double size_x, double size_y, double size_z, double val, double replaceval) {
	unsigned long xx,yy,zz,sx,sy,sz,sizex,sizey,sizez;
	uint32_t value,replacevalue;
	if(selectedbin==NULL) return -1;
	sx = (unsigned long) x;
	sy = (unsigned long) y;
	sz = (unsigned long) z;
	sizex = (unsigned long) size_x;
	sizey = (unsigned long) size_y;
	sizez = (unsigned long) size_z;
	if(!(sx+sizex<=selectedbin->x && sy+sizey<=selectedbin->y && sz+sizez<=selectedbin->z)) {
		return 0;
	}
	value = (uint32_t) val;
	replacevalue = (uint32_t) replaceval;
	for(zz=0;zz<sizez;++zz) {
		for(yy=0;yy<sizey;++yy) {
			for(xx=0;xx<sizex;++xx) {
				if(bin_get(selectedbin,sx+xx,sy+yy,sz+zz)>=value) {
					bin_set(selectedbin,sx+xx,sy+yy,sz+zz,replacevalue);
				}
			}
		}
	}
	return 1;
}

gmexport double ds_bin_replacelessthan_region(double x, double y, double z, double size_x, double size_y, double size_z, double val, double replaceval) {
	unsigned long xx,yy,zz,sx,sy,sz,sizex,sizey,sizez;
	uint32_t value,replacevalue;
	if(selectedbin==NULL) return -1;
	sx = (unsigned long) x;
	sy = (unsigned long) y;
	sz = (unsigned long) z;
	sizex = (unsigned long) size_x;
	sizey = (unsigned long) size_y;
	sizez = (unsigned long) size_z;
	if(!(sx+sizex<=selectedbin->x && sy+sizey<=selectedbin->y && sz+sizez<=selectedbin->z)) {
		return 0;
	}
	value = (uint32_t) val;
	replacevalue = (uint32_t) replaceval;
	for(zz=0;zz<sizez;++zz) {
		for(yy=0;yy<sizey;++yy) {
			for(xx=0;xx<sizex;++xx) {
				if(bin_get(selectedbin,sx+xx,sy+yy,sz+zz)<value) {
					bin_set(selectedbin,sx+xx,sy+yy,sz+zz,replacevalue);
				}
			}
		}
	}
	return 1;
}

gmexport double ds_bin_replacelessthanorequal_region(double x, double y, double z, double size_x, double size_y, double size_z, double val, double replaceval) {
	unsigned long xx,yy,zz,sx,sy,sz,sizex,sizey,sizez;
	uint32_t value,replacevalue;
	if(selectedbin==NULL) return -1;
	sx = (unsigned long) x;
	sy = (unsigned long) y;
	sz = (unsigned long) z;
	sizex = (unsigned long) size_x;
	sizey = (unsigned long) size_y;
	sizez = (unsigned long) size_z;
	if(!(sx+sizex<=selectedbin->x && sy+sizey<=selectedbin->y && sz+sizez<=selectedbin->z)) {
		return 0;
	}
	value = (uint32_t) val;
	replacevalue = (uint32_t) replaceval;
	for(zz=0;zz<sizez;++zz) {
		for(yy=0;yy<sizey;++yy) {
			for(xx=0;xx<sizex;++xx) {
				if(bin_get(selectedbin,sx+xx,sy+yy,sz+zz)<=value) {
					bin_set(selectedbin,sx+xx,sy+yy,sz+zz,replacevalue);
				}
			}
		}
	}
	return 1;
}

// (unary) boolean functions

gmexport double ds_bin_boolean_not_region(double x, double y, double z, double size_x, double size_y, double size_z) {
	unsigned long xx,yy,zz,sx,sy,sz,sizex,sizey,sizez;
	if(selectedbin==NULL) return -1;
	sx = (unsigned long) x;
	sy = (unsigned long) y;
	sz = (unsigned long) z;
	sizex = (unsigned long) size_x;
	sizey = (unsigned long) size_y;
	sizez = (unsigned long) size_z;
	if(!(sx+sizex<=selectedbin->x && sy+sizey<=selectedbin->y && sz+sizez<=selectedbin->z)) {
		return 0;
	}
	for(zz=0;zz<sizez;++zz) {
		for(yy=0;yy<sizey;++yy) {
			for(xx=0;xx<sizex;++xx) {
				bin_set(selectedbin,sx+xx,sy+yy,sz+zz, !( bin_get(selectedbin,sx+xx,sy+yy,sz+zz) ) );
			}
		}
	}
	return 1;
}

// (unary) bitwise functions

gmexport double ds_bin_bitwise_not_region(double x, double y, double z, double size_x, double size_y, double size_z) {
	unsigned long xx,yy,zz,sx,sy,sz,sizex,sizey,sizez;
	if(selectedbin==NULL) return -1;
	sx = (unsigned long) x;
	sy = (unsigned long) y;
	sz = (unsigned long) z;
	sizex = (unsigned long) size_x;
	sizey = (unsigned long) size_y;
	sizez = (unsigned long) size_z;
	if(!(sx+sizex<=selectedbin->x && sy+sizey<=selectedbin->y && sz+sizez<=selectedbin->z)) {
		return 0;
	}
	for(zz=0;zz<sizez;++zz) {
		for(yy=0;yy<sizey;++yy) {
			for(xx=0;xx<sizex;++xx) {
				bin_set(selectedbin,sx+xx,sy+yy,sz+zz, ~( bin_get(selectedbin,sx+xx,sy+yy,sz+zz) ) );
			}
		}
	}
	return 1;
}

gmexport double ds_bin_bitwise_lshift_region(double x, double y, double z, double size_x, double size_y, double size_z, double bits) {
	unsigned long xx,yy,zz,sx,sy,sz,sizex,sizey,sizez;
	unsigned char shiftbits;
	if(selectedbin==NULL) return -1;
	sx = (unsigned long) x;
	sy = (unsigned long) y;
	sz = (unsigned long) z;
	sizex = (unsigned long) size_x;
	sizey = (unsigned long) size_y;
	sizez = (unsigned long) size_z;
	if(!(sx+sizex<=selectedbin->x && sy+sizey<=selectedbin->y && sz+sizez<=selectedbin->z)) {
		return 0;
	}
	shiftbits = (unsigned char) bits;
	for(zz=0;zz<sizez;++zz) {
		for(yy=0;yy<sizey;++yy) {
			for(xx=0;xx<sizex;++xx) {
				bin_set(selectedbin,sx+xx,sy+yy,sz+zz, bin_get(selectedbin,sx+xx,sy+yy,sz+zz) << shiftbits );
			}
		}
	}
	return 1;
}

gmexport double ds_bin_bitwise_rshift_region(double x, double y, double z, double size_x, double size_y, double size_z, double bits) {
	unsigned long xx,yy,zz,sx,sy,sz,sizex,sizey,sizez;
	unsigned char shiftbits;
	if(selectedbin==NULL) return -1;
	sx = (unsigned long) x;
	sy = (unsigned long) y;
	sz = (unsigned long) z;
	sizex = (unsigned long) size_x;
	sizey = (unsigned long) size_y;
	sizez = (unsigned long) size_z;
	if(!(sx+sizex<=selectedbin->x && sy+sizey<=selectedbin->y && sz+sizez<=selectedbin->z)) {
		return 0;
	}
	shiftbits = (unsigned char) bits;
	for(zz=0;zz<sizez;++zz) {
		for(yy=0;yy<sizey;++yy) {
			for(xx=0;xx<sizex;++xx) {
				bin_set(selectedbin,sx+xx,sy+yy,sz+zz, bin_get(selectedbin,sx+xx,sy+yy,sz+zz) >> shiftbits );
			}
		}
	}
	return 1;
}

// boolean functions (not useful here)

// bitwise functions

gmexport double ds_bin_bitwise_and_region(double x, double y, double z, double size_x, double size_y, double size_z, double val) {
	unsigned long xx,yy,zz,sx,sy,sz,sizex,sizey,sizez;
	uint32_t value;
	if(selectedbin==NULL) return -1;
	sx = (unsigned long) x;
	sy = (unsigned long) y;
	sz = (unsigned long) z;
	sizex = (unsigned long) size_x;
	sizey = (unsigned long) size_y;
	sizez = (unsigned long) size_z;
	if(!(sx+sizex<=selectedbin->x && sy+sizey<=selectedbin->y && sz+sizez<=selectedbin->z)) {
		return 0;
	}
	value = (uint32_t) val;
	for(zz=0;zz<sizez;++zz) {
		for(yy=0;yy<sizey;++yy) {
			for(xx=0;xx<sizex;++xx) {
				bin_set(selectedbin,sx+xx,sy+yy,sz+zz, bin_get(selectedbin,sx+xx,sy+yy,sz+zz) & value );
			}
		}
	}
	return 1;
}

gmexport double ds_bin_bitwise_or_region(double x, double y, double z, double size_x, double size_y, double size_z, double val) {
	unsigned long xx,yy,zz,sx,sy,sz,sizex,sizey,sizez;
	uint32_t value;
	if(selectedbin==NULL) return -1;
	sx = (unsigned long) x;
	sy = (unsigned long) y;
	sz = (unsigned long) z;
	sizex = (unsigned long) size_x;
	sizey = (unsigned long) size_y;
	sizez = (unsigned long) size_z;
	if(!(sx+sizex<=selectedbin->x && sy+sizey<=selectedbin->y && sz+sizez<=selectedbin->z)) {
		return 0;
	}
	value = (uint32_t) val;
	for(zz=0;zz<sizez;++zz) {
		for(yy=0;yy<sizey;++yy) {
			for(xx=0;xx<sizex;++xx) {
				bin_set(selectedbin,sx+xx,sy+yy,sz+zz, bin_get(selectedbin,sx+xx,sy+yy,sz+zz) | value );
			}
		}
	}
	return 1;
}

gmexport double ds_bin_bitwise_xor_region(double x, double y, double z, double size_x, double size_y, double size_z, double val) {
	unsigned long xx,yy,zz,sx,sy,sz,sizex,sizey,sizez;
	uint32_t value;
	if(selectedbin==NULL) return -1;
	sx = (unsigned long) x;
	sy = (unsigned long) y;
	sz = (unsigned long) z;
	sizex = (unsigned long) size_x;
	sizey = (unsigned long) size_y;
	sizez = (unsigned long) size_z;
	if(!(sx+sizex<=selectedbin->x && sy+sizey<=selectedbin->y && sz+sizez<=selectedbin->z)) {
		return 0;
	}
	value = (uint32_t) val;
	for(zz=0;zz<sizez;++zz) {
		for(yy=0;yy<sizey;++yy) {
			for(xx=0;xx<sizex;++xx) {
				bin_set(selectedbin,sx+xx,sy+yy,sz+zz, bin_get(selectedbin,sx+xx,sy+yy,sz+zz) ^ value );
			}
		}
	}
	return 1;
}

gmexport double ds_bin_bitwise_nand_region(double x, double y, double z, double size_x, double size_y, double size_z, double val) {
	unsigned long xx,yy,zz,sx,sy,sz,sizex,sizey,sizez;
	uint32_t value;
	if(selectedbin==NULL) return -1;
	sx = (unsigned long) x;
	sy = (unsigned long) y;
	sz = (unsigned long) z;
	sizex = (unsigned long) size_x;
	sizey = (unsigned long) size_y;
	sizez = (unsigned long) size_z;
	if(!(sx+sizex<=selectedbin->x && sy+sizey<=selectedbin->y && sz+sizez<=selectedbin->z)) {
		return 0;
	}
	value = (uint32_t) val;
	for(zz=0;zz<sizez;++zz) {
		for(yy=0;yy<sizey;++yy) {
			for(xx=0;xx<sizex;++xx) {
				bin_set(selectedbin,sx+xx,sy+yy,sz+zz, ~( bin_get(selectedbin,sx+xx,sy+yy,sz+zz) & value ) );
			}
		}
	}
	return 1;
}

gmexport double ds_bin_bitwise_nor_region(double x, double y, double z, double size_x, double size_y, double size_z, double val) {
	unsigned long xx,yy,zz,sx,sy,sz,sizex,sizey,sizez;
	uint32_t value;
	if(selectedbin==NULL) return -1;
	sx = (unsigned long) x;
	sy = (unsigned long) y;
	sz = (unsigned long) z;
	sizex = (unsigned long) size_x;
	sizey = (unsigned long) size_y;
	sizez = (unsigned long) size_z;
	if(!(sx+sizex<=selectedbin->x && sy+sizey<=selectedbin->y && sz+sizez<=selectedbin->z)) {
		return 0;
	}
	value = (uint32_t) val;
	for(zz=0;zz<sizez;++zz) {
		for(yy=0;yy<sizey;++yy) {
			for(xx=0;xx<sizex;++xx) {
				bin_set(selectedbin,sx+xx,sy+yy,sz+zz, ~( bin_get(selectedbin,sx+xx,sy+yy,sz+zz) | value ) );
			}
		}
	}
	return 1;
}

gmexport double ds_bin_bitwise_nxor_region(double x, double y, double z, double size_x, double size_y, double size_z, double val) {
	unsigned long xx,yy,zz,sx,sy,sz,sizex,sizey,sizez;
	uint32_t value;
	if(selectedbin==NULL) return -1;
	sx = (unsigned long) x;
	sy = (unsigned long) y;
	sz = (unsigned long) z;
	sizex = (unsigned long) size_x;
	sizey = (unsigned long) size_y;
	sizez = (unsigned long) size_z;
	if(!(sx+sizex<=selectedbin->x && sy+sizey<=selectedbin->y && sz+sizez<=selectedbin->z)) {
		return 0;
	}
	value = (uint32_t) val;
	for(zz=0;zz<sizez;++zz) {
		for(yy=0;yy<sizey;++yy) {
			for(xx=0;xx<sizex;++xx) {
				bin_set(selectedbin,sx+xx,sy+yy,sz+zz, ~( bin_get(selectedbin,sx+xx,sy+yy,sz+zz) ^ value ) );
			}
		}
	}
	return 1;
}

